# Linux Kernel Module Cheat

###### 27.3.1.1.1. C++ rule of five

userland/cpp/rule_of_five.cpp

Output Ubuntu 20.04 GCC 9.3:

    constructor?
    constructor

    copy?
    constructor
    copy

    copy assignment?
    constructor
    copy assignment
    constructor
    copy
    move assignment
    destructor

    move?
    constructor

    move?
    constructor
    constructor
    move assignment
    destructor

    a bunch of destructors?
    destructor
    destructor
    destructor
    destructor
    destructor

https://en.cppreference.com/w/cpp/language/rule_of_three